init_sam_prog=init_sam.sh
if ([ $# -lt 1 ] || ! [ -d $1 ]) then
  echo "$init_sam_prog: you must supply a valid sam client dir" >&2
  return 1
else
  sam_client_dir=$1
  sam_client_dir=`cd $sam_client_dir; pwd`
  echo $1 sam_client_dir=$sam_client_dir

  export PATH=$sam_client_dir/sam_cp/bin:$sam_client_dir/xmldb_client/bin:$PATH
  export PATH=$sam_client_dir/jim_config/bin:$sam_client_dir/fcp/bin:$PATH
  export PATH=$sam_client_dir/sam_fcp/bin:$sam_client_dir/jim_gridftp/bin/:$PATH
  export PATH=$sam_client_dir/merge_plugin_cdf/bin:$PATH
  export PATH=$sam_client_dir/jim_merge/bin:$PATH
  export PATH=$sam_client_dir/sam/bin:$sam_client_dir/python/bin:$PATH


  #export variables needed by sam_cp
  export SAM_CP_DIR=${sam_client_dir}/sam_cp/
  export SAM_CP_CONFIG_DIR=${sam_client_dir}/sam_cp_config/
  export SAM_CP_ARBITRATOR_MODULE_FILE=${sam_client_dir}/sam_cp/lib/SamCpProtocolArbitrator.py
  export SAM_CP_ARBITRATOR_CLASS_NAME=SamCpDefaultProtocolArbitrator
  export SAM_CP_CONFIG_MGR_MODULE_FILE=${sam_client_dir}/sam_cp/lib/SamCpConfigManager.py
  export SAM_CP_CONFIG_MGR_CLASS_NAME=SamCpDefaultConfigManager
  
  
  export SAM_DIR=$sam_client_dir/sam/
  export JIM_GRIDFTP_DIR=$sam_client_dir/jim_gridftp/
  export JIM_CONFIG_DIR=$sam_client_dir/jim_config/
  export FCP_DIR=$sam_client_dir/fcp/
  export SAM_FCP_DIR=$sam_client_dir/sam_fcp/
  export JIM_MERGE_DIR=$sam_client_dir/jim_merge/
  export LD_LIBRARY_PATH=$SAM_DIR/samlib/:$LD_LIBRARY_PATH
  export PYTHONHOME=$sam_client_dir/python

     
  #Resetting PYTHONPATH
  export PYTHONPATH=$sam_client_dir/xmldb_client/lib:$PYTHONPATH
  export PYTHONPATH=$sam_client_dir/jim_merge/src/python:$PYTHONPATH
  export PYTHONPATH=$sam_client_dir/sam_cp/src:$sam_client_dir/sam_cp/lib:$PYTHONPATH
  export PYTHONPATH=$sam_client_dir/fcslib/lib:$PYTHONPATH
  export PYTHONPATH=$sam_client_dir/jim_config/lib:$PYTHONPATH
  export PYTHONPATH=$sam_client_dir/merge_plugin_cdf/src/python:$PYTHONPATH
  export PYTHONPATH=$sam_client_dir/xml_common_lib/lib:$PYTHONPATH
  export PYTHONPATH=$sam_client_dir/python/lib/python2.4:$PYTHONPATH
  export PYTHONPATH=$sam_client_dir/xmldb_client/lib:$PYTHONPATH
  export PYTHONPATH=$SAM_DIR/samlib:$SAM_DIR/samlib/sam_pyclib.zip:$PYTHONPATH
  export PYTHONPATH=$sam_client_dir/pyxml/lib:$PYTHONPATH
  echo ""
  echo "======================================================================="
  echo "$init_sam_prog: using python `which python` with PYTHONPATH=$PYTHONPATH"
  echo "======================================================================="
  echo ""

  export SAM_NAMING_SERVICE=d0db.fnal.gov:9010
  export SAM_NAMING_SERVICE_IOR=IOR:000000000000002a49444c3a6f6f632e636f6d2f436f734e616d696e672f4f424e616d696e67436f6e746578743a312e3000000000000001000000000000002c000100000000001064306f7261322e666e616c2e676f7600233200000000000c4e616d655365727669636500
  export SAM_NAMING_SERVICE_IOR=corbaname::samns-d0.fnal.gov:9010
  export SAM_DB_SERVER_NAME=SAMDbServer.user_prd2:SAMDbServer
  export SAM_DB_SERVER_LEVEL=3:-1
  # Dummy Variable necessary for cdfsoft
  export SETUP_SAM="sam v8_1_5"
  # For omniorb to disable ORB from using end point connection
  export ORBendPoint=giop:tcp:`$sam_client_dir/nodeip`:
  if [ $? -ne 0 ]; then
    export ORBendPoint=giop:tcp:0.0.0.0:
    echo ""
    echo "======================================================================="
    echo "$init_sam_prog: failed to get local IP address ($ORBendPointPublish)"
    echo "======================================================================="
    echo ""
  fi
fi
  
