#!/usr/bin/env python

import sys, os
from JimConfigManager import JimConfigManager 
from xml_meta_configurator_lib.XMLDocTemplate import XMLDocTemplate

def usage():
    print "%s <template> [mode]"
    return 1
# usage

def main(argv):

    if (len(argv) < 2) or (len(argv) > 3):
        return usage()

    configTempl = argv[1]
    try:
       mode = argv[2]
    except:
       mode = 'DBFS'

    prdName = os.environ.get('UPS_PROD_NAME')
    if not prdName:
       print >> sys.stderr, 'ERROR: This script should be called from the ups only'
       return 1
    prdVersion = os.environ.get('UPS_PROD_VERSION')
    prdQualifiers = os.environ.get('UPS_PROD_QUALIFIERS')
    prdString = prdName + ' ' + prdVersion
    if (prdQualifiers) and (not prdQualifiers == ''):
         prdString = prdString + ' -q "' + prdQualifiers + '"'

    templ = XMLDocTemplate(configTempl)
    output = templ.instantiate()
  
    try:
       jim_config_man = JimConfigManager.JimConfigManager(prdName,
                                                          prdVersion,
                                                          prdQualifiers)
       jim_config_man.setMode(mode)
       jim_config_man.storeConfigString(output)
    except:
       print 'To configure this package run as products:\n'\
              + 'ups tailor '  + prdString
       return 1

    return 0
# main


if __name__ == "__main__":
    sys.exit(main(sys.argv))
