#!/usr/bin/env python

import sys
from JimConfigManager import JimConfigManager 

def usage():
    print "%s <template> [mode]"
    return 1

def main(argv):

    if (len(argv) < 2) or (len(argv) > 3):
        return usage()

    import os

    configTempl = argv[1]

    try:
       mode = argv[2]
    except:
       mode = 'DBFS'

    prdName = 'jim_config'

    from xml_meta_configurator_lib.XMLDocTemplate import XMLDocTemplate

    templ = XMLDocTemplate(configTempl)
    output = templ.instantiate()
  
    try:
       jim_config_man = JimConfigManager.JimConfigManager(prdName)
       jim_config_man.setMode(mode)
       jim_config_man.storeSiteConfigString(output)
    except:
       print 'ERROR - Site configuration was unsuccessfull\n'
       return 1

    return 0

if __name__ == "__main__":
    sys.exit(main(sys.argv))
