#!/usr/bin/env python

from JimConfigManager.JimConfigManagerCommand import JimConfigManagerCommand

import sys, os, traceback

def main(argv):

   jcm = JimConfigManagerCommand()

   if (len(argv) < 2):
      jcm.PrintDefault()
      sys.exit(0)
   
   try:
      # Check if the command is a client command
      if (jcm.clicommands[argv[1]]):
         try:
            jcm.clicommands[argv[1]](argv[2])
         except IndexError, e:
            jcm.clicommands[argv[1]]()
   except KeyError, e:
      try:
         # Check if action is valid
         test = jcm.helper[argv[1]][0]
        
         # Check if options are valid
         result = jcm.CheckOptions(argv)
         if (result):
            raise jcm.JCMCommandException, "Invalid Option in arguments"
      
         # Now Invoke the API
         res = jcm.InvokeApi(argv[1])
         print res
      
      except:
         print>>sys.stderr, "Command is invalid"
         if os.environ.get('JIM_CONFIG_MANAGER_DEBUG_MODE','FALSE') == 'TRUE':
            traceback.print_exc()
         sys.exit(1)
# main
   
   
if __name__ == "__main__":
   sys.exit(main(sys.argv))
