#!/usr/bin/env python
#=============================================================================
#
#Project   : JIM
#Package : jim_config
#$Id: jim_sam_storage_negotiator_cmd.py,v 1.1 2005/07/08 20:03:04 abaranov Exp $
#
#This work is part of a development project, called JIM, which consists of a
#number of coordinated packages each named sam_xxxx .
#
#Notice of authorship, copyright status,  and terms and conditions, should
#the software eventually become available for use outside Fermilab, can be
#found in the README and LICENCE files in the top level directory of the main
#sam package.
#
#==============================================================================

import jim_sam_storage_negotiator

def main(action,station,applname):

   if ( action == "store" ):
      (location, access_q ) = jim_sam_storage_negotiator.jim_sam_outgoing_storage_negotiator(station,applname)
   else: 
     if ( action == "retrieve" ):
        (location , access_q ) = jim_sam_storage_negotiator.jim_sam_incoming_storage_negotiator(station,applname)
     else: 
        raise Exception("Unknown command, accepted <store|retrieve>")

   if ( not ( location and len(location) )):
     location = ""
   if ( not (access_q and len(access_q) )):
     access_q = ""

   print "LOCATION="+location+";"
   print "ACCESS_Q="+access_q+";"

def usage():
  print "Usage: <store|retrieve> <station> <appname>"

if __name__ == "__main__":
   import sys
   if ( len(sys.argv) < 4 ):
      usage()
      sys.exit(1)

   action = sys.argv[1]
   station = sys.argv[2]
   appname = sys.argv[3]
   main(action,station,appname)
   
