#!/usr/bin/env python

#############################################################################
# Project   : JIM
# Package : xml_common_lib
# $Id: url_read_config_value.py,v 1.1 2003/04/15 15:43:37 terekhov Exp $
#
# This work is part of a development project, called JIM, which consists of a
# number of coordinated packages each named jim_xxxx .
#
# Notice of authorship, copyright status,  and terms and conditions, should
# the software eventually become available for use outside Fermilab, can be
# found in the README and LICENCE files in the top level directory of the main
# sam package.
#############################################################################


import sys,string

def xpath2opath(xpath):
    """Convert an xpath string to an 'path' into a PY XML object"""

    #Strip off leading and trailing '/'
    if xpath[0] == '/': xpath=xpath[1:]
    if xpath[-1] == '/': xpath=xpath[0:-1]
    
    #XML elements may have '-' but PY objects cannot
    result = string.replace(xpath,'-','_')

    #nested elements correspond to referencing a python attribute
    #We take [0] assuming there is only one element with given name
    result = string.replace(result, '/', '[0].')

    return result
#xpath2opath

def getAttrFromXMLFile(file_path, xpath):
    """Returns a string value of an attribute given by xpath.
    The xpath must be absolute, be simple i.e. not contain predicates
    and end with the attribute name."""

    from xml_common_lib.Xml2ObjectBuilder import Xml2ObjectBuilder
    obj = Xml2ObjectBuilder(open(file_path,"rt")).getRoot()
    return eval('obj.%s' % xpath2opath(xpath))

#getAttrFromXMLFile

def main(args):

    if len(args) < 4:
        raise "Usage: url_read_config_value <URL> <subsystem> <xpath> <attr>"

    url = args[1]
    subsystem = args[2]
    xpath = args[3]
    attr = args[4]
    if url[0:5] == "file:":
        print getAttrFromXMLFile\
              (args[1][5:] + '/' + subsystem, xpath + '/' + attr)
    else:
        #Assume it's a xindice url
        #fixme: use API?
        os.execvp ("python", ["python", "read_xml_value.py",
                              url, subsystem, xpath, attr])
        
if __name__ == '__main__':
    sys.exit(main(sys.argv))
