"""
This python library makes managing the site configuration easy
"""

__author__="Parag Mhashilkar <parag@fnal.gov>"
__date__= "May 02 2003"
__version__="1.0"

# $source: SiteDBConfigManager.py,v$

################################################################################
# Project   : SAM
# Package : jim_config
#
# This work is part of a development project, called JIM, which consists of a
# number of coordinated packages each named jim_xxxx .
#
# Notice of authorship, copyright status,  and terms and conditions, should
# the software eventually become available for use outside Fermilab, can be
# found in the README and LICENCE files in the top level directory of the main
# sam package.
################################################################################

import os, string, sys
import xml_common_lib
from BaseDBConfigManager import BaseDBConfigManager
from BaseFSConfigManager import BaseFSConfigManager


#####################################################################################
# Class: SiteDBConfigManager
#####################################################################################
 

class SiteDBConfigManager(BaseDBConfigManager):
   """This utility class manages the configuration storing and retrival from Db"""

   def __init__(self, name='site', version=None, qual=None):
      """
         Contructor to create a SiteDBConfigManager

         name - Name of the package
      """

      try:
        name = 'site'
        BaseDBConfigManager.__init__(self, name)

        self.context = self.getSiteContext()
        self.configDoc = self.getSiteConfigDocName()
        self.printConfigDetails()
      except:
         import traceback
         if self.getDebugMode(): traceback.print_exc()
         raise self.ConfigManagerError('error XML DB config error')

   # __init__


# Class SiteDBConfigManager


#####################################################################################
# Class: SiteFSConfigManager
#####################################################################################
 

class SiteFSConfigManager(BaseFSConfigManager):
   """This utility class manages the configuration storing and retrival from Db"""

   def __init__(self, name='site', version=None, qual=None):
      """
         Contructor to create a SiteFSConfigManager

         name - Name of the package
      """

      name = 'site'
      BaseFSConfigManager.__init__(self, name)

      self.path = self.getSitePath()
      self.configDoc = self.getSiteConfigDocName()
      self.printConfigDetails()
   # __init__


# Class SiteFSConfigManager
