#!/bin/sh
thisDir=`pwd`

theProj=`basename ${thisDir}`
depend_file=DEPENDENCIES

productList=""
if [ -f ${depend_file} ]; then
    productList="${productList} `cat $depend_file`"
fi

echo "Setting up ${theProj} -q build from this directory..."
setup ${theProj} -P -r $PWD -Mups -Uups -m${theProj}.table -q build

for dep in ${productList}; do
    if ups exist ${dep} -P -r $PWD/../${dep} -Mups -Uups -m${dep}.table; then
        echo "Setting up ${dep} -j -q build ..."
        setup ${dep} -j -P -r $PWD/../${dep} -Mups -Uups -m${dep}.table -qbuild
    elif ups exist ${dep}; then
        echo "Setting up INSTALLED ${dep} -j -q build..."
	setup ${dep} -j -q build
    else
	echo "Product not found: ${dep}"
    fi
done

unset theProj
unset projectList
unset depend_file
