#!/usr/bin/env sampy
import sys
import os
import os.path
import string

def getSamCpImportManager():
    try:
        importManager = SamCpImportManager()
    except SamCpImportManager, ex:
        importManager = ex
    return importManager

class SamCpImportManager:
    """
    A singleton class to handle importing of python files
    from a specific location
    """
    _singleton = None
    def __init__(self):
        if SamCpImportManager._singleton is not None:
            raise SamCpImportManager._singleton
        SamCpImportManager._singleton = self

    def importObjectFromFile(self, objectNameToImport, fullPathToFile):
        # expand any environmental variables
        expandedModuleFile = os.path.expandvars(fullPathToFile)

        # get the path and the module name, sans ".py"
        moduleDir = os.path.dirname(expandedModuleFile)
        moduleFile = string.replace(os.path.basename(expandedModuleFile), '.py', '')

        # make sure that this path is included at the front of our $PYTHONPATH
        if moduleDir not in sys.path:
            sys.path.insert(0, moduleDir)

        # create a string of the form:
        #   from moduleName import objectNameToImport
        importCommand = "from %s import %s" % (moduleFile, objectNameToImport)

        # execute this command to import the module
        exec importCommand

        # create a string of the form:
        #   return objectNameToImport
        returnObjectCommand = "returnObject = %s" % objectNameToImport

        # execute this command
        exec returnObjectCommand

        # return the imported object to the caller
        return returnObject
        
        
