#!/usr/bin/env python
#############################################################################
# Project   : JIM
# Package : xmldb_client
# $Id: read_xml_value.py,v 1.3 2003/04/15 20:46:47 abaranov Exp $
#
# This work is part of a development project, called JIM, which consists of a
# number of coordinated packages each named jim_xxxx .
#
# Notice of authorship, copyright status,  and terms and conditions, should
# the software eventually become available for use outside Fermilab, can be
# found in the README and LICENCE files in the top level directory of the main
# sam package.
#############################################################################

import sys

def printerr(str):
  sys.stderr.write(str)
  sys.stderr.write("\n")
  
def usage():
  printerr("Usage : %s db_addr collection XPath attribute" % sys.argv[0] )
  return 1


def main(argv):

  if len(argv) != 5:
    return usage()

  from xmldb_client import xmldb

  db_addr = sys.argv[1]
  collection = sys.argv[2]
  path = sys.argv[3]
  attr = sys.argv[4]

  import xmldb_client.xmlxpath_tools
  try:
    print xmldb_client.xmlxpath_tools.readValue(xmldb.xmldb(db_addr),collection,path,attr)
  except Exception,ex:
    printerr(str(ex))
    return 1
#main

if __name__ == '__main__':
  sys.exit(main(sys.argv))
