#!/usr/bin/env python
#############################################################################
# Project   : JIM
# Package : xmldb_client
# $Id: set_xml_value.py,v 1.3 2006/03/09 20:35:29 parag Exp $
#
# This work is part of a development project, called JIM, which consists of a
# number of coordinated packages each named jim_xxxx .
#
# Notice of authorship, copyright status,  and terms and conditions, should
# the software eventually become available for use outside Fermilab, can be
# found in the README and LICENCE files in the top level directory of the main
# sam package.
#############################################################################

import sys
from types import *

def printerr(str):
  sys.stderr.write(str)
  sys.stderr.write("\n")
  
def usage():
  printerr("Usage : %s db_addr collection XPath attribute" % sys.argv[0] )
  return 1


def main(argv):

  if len(argv) != 5:
    return usage()

  from xmldb_client import xmldb

  db_addr = sys.argv[1]
  collection = sys.argv[2]
  path = sys.argv[3]
  attr = sys.argv[4]

  try:
    xml_db_conn = xmldb.xmldb(db_addr);

    from xml_common_lib.PyXmlObject import PyXmlObject
    
    txt=xml_db_conn.QueryCollection(collection,path)
    
    result=PyXmlObject(txt)
    
    if result.result[0].count == "0":
      printerr("Value is not found")
      return 1

    
    for (key,value) in result.result[0].__dict__.items():
      if type(value) is ListType:
        for listEl in value[:]:
          print listEl.__dict__[attr]
          
  except KeyError,ex:
    printerr("Failed to query db %s collection %s xpath %s, key is not found %s"%(db_addr,collection,path,ex))
    return 1
  except:
    printerr("Failed to query db %s collection %s xpath %s"%(db_addr,collection,path))
    return 1
#main

if __name__ == '__main__':
  sys.exit(main(sys.argv))
