#
#A small set of test cases to test idmgr
# 

import xmldb_client.idmgr

print "\n Creating Id Manager";
testObj = xmldb_client.idmgr.idmgr();

print "\n Calling the API Version";
print testObj.GetApiVersion();

print"\n Configuration Settings..."
print testObj.GetConf();

gid="gram:sammy.fnal.gov:8070"

doc = """<Project Type='SAM'> 
          <Site name ='samadams.fnal.gov' />
	   <Project name='DZero' />
	   <TTL>15seconds</TTL>
         </Project>"""

print "\n Create a Global Job document with Id %s & some eleements declared inside...." %gid
print testObj.CreateGlobalJob(gid,doc);

print "\n Print the new Global Job document with Id %s...." %gid
print testObj.GetGlobalJob(gid);

gid="gram:samadams.fnal.gov:8070"
cid="http://sameggs.fnal.gov"
cluster="eggs"
lid_1="vijay_sameggs98765432"
lid_2="vijay_sameggs12345678;Semicolon"


print "\n Create a empty global job document..."
print testObj.CreateGlobalJob(gid);

print "\n Create a new cluster job %s inside global job ..." %cid
print testObj.CreateClusterJob(gid,cid,cluster);

print "\n Create a new local job %s inside cluster job ..." %lid_1
print testObj.CreateLocalJob(gid,cid,lid_1);

print "\n Print the Global document with %s ...." %gid
print testObj.GetGlobalJob(gid);

print "\n Deleting local job inside cluster job ..."
print testObj.RemoveLocalJob(gid,cid,lid_1);

print "\n Create a  another local job inside cluster job ..."
print testObj.CreateLocalJob(gid,cid,lid_2);

select='/global_job/cluster_job/local_job[@Id="%s"]' %lid_2 
str ="<status>Hey</status>"

print "\n Modifying a local jobs..."
print testObj.UpdateJobs("append",select,str)

print "\n Print the Global document with Id ...."
print testObj.GetGlobalJob(gid)

str = "<test name='none'><success>something</success></test>"

print "\n Append %s to a Global job..." %(str)
print testObj.UpdateGlobal("append",gid,str)

print "\n Appending more data based on a customized xpath"
more_str = "<add_more>Hee</add_more>"
print testObj.UpdateGlobal("append",gid,more_str,"/test")


print "\n Print the Global document with Id 200...."
print testObj.GetGlobalJob(gid)

print "\n Append %s to a cluster job..." %(str)
print testObj.UpdateCluster("append",gid,cid,str)

print "\n Print the Cluster document with GID = %s CID = %s...." %(gid,cid)
print testObj.GetClusterJob(gid,cid)

print "\n Append %s to a Local job..." %(str)
print testObj.UpdateLocal("append",gid,cid,lid_2,str)

print "\n Print the Local document with GID= %s CID=%s LID = %s...." %(gid,cid,lid_2)
print testObj.GetLocalJob(gid,cid,lid_2)

print "\n Query all the Jobs for some information..."
print testObj.QueryJobs("/global_job/cluster_job");

print "\n Query for some specific information within a Global Job...."
print testObj.QueryJob(gid,"/global_job/cluster_job[@cluster='eggs']")

print "\n Deleteling a Global job"
print testObj.RemoveGlobalJob(gid);


