#
#A small set of test cases to test idmgr
# 

from xmldb_client import idmgr,xmldb
import sys

if len(sys.argv) > 1: server_url = sys.argv[1]
else: server_url = "http://samadams.fnal.gov:9080/Xindice"
collection = "/db/jobs"
print "\n Creating Id Manager from ", server_url ;
testObj = idmgr.idmgr(server_url, collection);

print "\n Calling the API Version";
print testObj.GetApiVersion();

print"\n Configuration Settings..."
print testObj.GetConf();

gjid = "terekhov_sameeggs123456789"
gjid = "100"

print"\n Cleaning up any previous entries"
try: print testObj.RemoveGlobalJob(gjid)
except: pass

#print testObj.RemoveGlobalJob(gjid)

print "\n Create an Empty Global Job document with an Id ", gjid
print testObj.CreateGlobalJob(gjid);

print "\n Print the Empty Global Job document with Id 100...."
print testObj.GetGlobalJob(gjid);

cjid = "gram:http:sameggs.fnal.gov"
print "\n Create a cluster job associated with this global job id"
print "This will initially be the GRAM job id available in the job manager"
print testObj.CreateClusterJob(gjid, cjid,"eggs","")
print testObj.GetGlobalJob(gjid);
                               
ljid = "localuser_789"
#ljid = "789"
print "\n Create a local job ID within this cluster job"
print testObj.CreateLocalJob(gjid,cjid,ljid)
print "\n Seeing our results:"
print testObj.GetGlobalJob(gjid)

print "\n Add some status history elements into it..."
addInfo = "<status time='%s' code='running'/>" % testObj.getCurTime()
path = '/global_job/cluster_job/local_job[@Id=&quot;%s&quot;]' % ljid

xupdate = xmldb.XUpdateBuilder()
modification = xupdate.build('append',path,addInfo)

print 'MODICIFACTION: ', gjid, modification
print testObj.UpdateDocument(collection, gjid, modification)

print "\n Seeing our results after UpdateDocument"
print testObj.GetGlobalJob(gjid)

import time
time.sleep(1)
print "\n After 1 second, change status again"

#string.replace(modification,'running','stopped
addInfo = "<status time='%s' code='stopped'/>" % testObj.getCurTime()
modification = xupdate.build('append',path,addInfo)
print testObj.UpdateDocument(collection, gjid, modification)
print "\n Seeing our results after UpdateDocument"
print testObj.GetGlobalJob(gjid)


query = '/global_job/cluster_job/local_job[@Id="%s"]/status' % ljid
from xml_common_lib.PyXmlObject import PyXmlObject
obj = PyXmlObject(testObj.QueryDocument(collection,gjid,query))
print "\nThe status of our local job now is ***%s***\n\n" % \
      obj.result[0].status[-1].code



print 
print 'BOOOOO'
print


#print testObj.AddElements("100",doc);

#doc = "<local experiment='DZero' />"
#print testObj.AddElements("100",doc);

#print "\n Print the Global document with Id 100...."
#print testObj.GetGlobalJob("100");

doc = """<Project Type='SAM' Id='10'> 
          <Site name ='samadams.fnal.gov' />
	   <Project name='DZero' />
	   <TTL>15seconds</TTL>
         </Project>"""

print "\n Create a new global job document with various elements declared inside it..."
print testObj.CreateGlobalJob("200",doc);

print "\n Create a new cluster job inside global job 200..."
print testObj.CreateClusterJob("200","100","samadams");

print "\n Create a new local job inside cluster job 100..."
print testObj.CreateLocalJob("200","100","150");

print "\n Create a new local job inside cluster job 100..."
print testObj.CreateLocalJob("200","100","151");

print "\n Create a new local job inside cluster job 100..."
print testObj.RemoveLocalJob("200","100","150");

print "\n Print the Global document with Id 200...."
print testObj.GetGlobalJob("200");

print "\n Query all the Jobs for some information..."
print testObj.QueryJobs("/global_job/cluster_job");

print "\n Query for some specific information within a Global Job...."
print testObj.QueryJob("200","/global_job/cluster_job[@Name='samadams']");

print "\n Deleteling a Global job"
print testObj.RemoveGlobalJob("200");
