#############################################################################
# Project   : JIM
# Package : xmldb_client
# $Id: xmlxpath_tools.py,v 1.3 2006/03/09 20:35:29 parag Exp $
#
# This work is part of a development project, called JIM, which consists of a
# number of coordinated packages each named jim_xxxx .
#
# Notice of authorship, copyright status,  and terms and conditions, should
# the software eventually become available for use outside Fermilab, can be
# found in the README and LICENCE files in the top level directory of the main
# sam package.
#############################################################################

from types import *

class ExtractorException(Exception):
  def __init__(self,what):
    self._what = what

  def __str__(self):
    return self._what
    
def readValue(xml_db_conn,collection,path,attr):
  
  try:

    from xml_common_lib.PyXmlObject import PyXmlObject
    
    if ( path[len(path)-1] != "]" ):
      path = path + "[@"+attr+"]"

    result=PyXmlObject(xml_db_conn.QueryCollection(collection,path))
    
    if result.result[0].count == "0":
      raise ExtractorException("Value is not found")
    
  
    for (key,value) in result.result[0].__dict__.items():
      if type(value) is ListType:
        for listEl in value[:]:
          return listEl.__dict__[attr]
          
  except KeyError,ex:
    raise ExtractorException("Failed to query db %s collection %s xpath %s, key %s is not found"%(xml_db_conn.GetUrl(),collection,path,ex))
  except:
    raise ExtractorException("Failed to query db %s collection %s xpath %s attr %s"%(xml_db_conn.GetUrl(),collection,path,attr))
#
